program exercise19
  implicit none

  integer :: i 
  real*8 :: x, h, diff3, diff5, diff7, diff9
  
  x = 1.0d0  ! xに1を代入 (他の値でも同じ分析が可能)
  print *, "analytic solution of df/dx: ", dfdx(x)  ! x=1でのdf/dxの値を表示

  ! 表の見出しを出力
  write(*,*) "        h           3-point        5-point        7-point        9-point"
  
  do i = 1, 7
  
     h = 10.0d0**(-i)  ! hの値をdo文で変えてゆく

     ! 3点、5点、7点、9点公式。関数f(x)は関数副プログラムで定義(あとで変更が容易)
     diff3 = ( -f(x-h)+ f(x+h) )/(2.0d0*h) 
     diff5 = ( f(x-2*h)-8.0d0*f(x-h)+ 8.0d0*f(x+h)-f(x+2*h) )/(12.0d0*h)
     diff7 = ( -f(x-3*h)+ 9.0d0*f(x-2*h)-45.0d0*f(x-h)+ 45.0d0*f(x+h)-9.0d0*f(x+2*h)+f(x+3.0*h) )/(60.0d0*h)
     diff9 = ( 3.0d0*f(x-4*h)-32.0d0*f(x-3*h)+168.0d0*f(x-2*h)-672.0d0*f(x-h)+672.0d0*f(x+h) &
          & -168.0d0*f(x+2*h)+32.0d0*f(x+3.0*h)-3.0d0*f(x+4*h) )/(840.0d0*h)

     ! 結果の出力。 差分の公式diff?と解析解dfdx(x)との差の絶対値を出力。
     ! '(5es15.5)'は出力フォーマット。es15.5で実数を15桁のサイズで、小数点以下は5桁で指数表示。5es15.5の先頭の5はそのような出力を5回繰り返すという指定
     write(*,'(5es15.5)') h, abs(diff3-dfdx(x)), abs(diff5-dfdx(x)), abs(diff7-dfdx(x)), abs(diff9-dfdx(x))
  
  end do
     
contains

  !関数副プログラムでf(x)を計算
  function f(x)
    real*8, intent(in) :: x
    real*8 :: f
    
    f = sin(x)

    return
    
  end function f

  !関数副プログラムでdf/dx(x)を計算
  function dfdx(x)
    real*8, intent(in) :: x
    real*8 :: dfdx
    
    dfdx = cos(x)

    return
    
  end function dfdx

end program exercise19
